# frozen_string_literal: true

# Base informational unit for timeline interface
module ResourcePlanner
  class EventUnit < ApplicationRecord

    belongs_to :event, :class_name => '::ResourcePlanner::Event'

    has_many :subscriptions, class_name: '::ResourcePlanner::EventUnitSubscription', inverse_of: :event_unit, dependent: :destroy
    accepts_nested_attributes_for :subscriptions, allow_destroy: true

    #has_many :resources, :through => :subscriptions

    #--------------------------------------------------------------------------

    #---------- Validations

    #---------- Scopes

    # scope :events, -> { ::ResourcePlanner::Event.events.collect(&:event_units).flatten.uniq }
    # scope :resource_availabilities, -> { ::ResourcePlanner::Event.resource_availabilities.collect(&:event_units).flatten.uniq }
    # scope :resource_restrictions, -> { ::ResourcePlanner::Event.resource_restrictions.collect(&:event_units).flatten.uniq }

    #---------- Callbacks

    #--------------------------------------------------------------------------

    def to_s
      "#{event} - #{start_at}-#{end_at}"
    end

    def all_day?
      all_day
    end

  end
end
